import statistics.LinearRegression;


public class SteadyStateAnalyzer {
	
	private double[] values;
	int counter = 0;
	
	private double mean;
	private double sigma;
	private double slope;

	public SteadyStateAnalyzer(int n){
		this.values = new double[n];
	}
	
	public void insertValue(double d){
		this.values[this.counter] = d;
		this.counter++;
		if (this.counter>=this.values.length){
			this.counter = 0;
		}
	}
	
	private void analyze(){
		this.mean = 0.0;
		for(int i=0; i<this.values.length; i++){
			this.mean += this.values[i];
		}
		this.mean /= this.values.length;
		this.sigma = 0;
		for(int i=0; i<this.values.length; i++){
			this.sigma += (this.values[i]-this.mean)*(this.values[i]-this.mean);
		}
		this.sigma /= this.values.length;
		this.sigma = Math.sqrt(this.sigma);
		
		LinearRegression lr = new LinearRegression();
		for(int i=this.counter; i<this.counter+this.values.length; i++){
			lr.addXY(i-this.counter, this.values[i % this.values.length]);
		}
		lr.calculate();
		this.slope = lr.getA();
	}
	
	public boolean isSteady(){
		this.analyze();
		if (this.slope*this.values.length < this.sigma)
			return true;
		return false;
	}
}
